#version 300 es
layout(location = 0) in vec2 iActiveDelay_Life;
layout(location = 1) in vec3 iPosition;
layout(location = 2) in float iAngle;
layout(location = 3) in float iTransparency;
layout(location = 4) in float iScale;

uniform mat4 uMVPMatrix;
uniform float uPointSize;

out float vAngle;
out float vTransparency;
out float vScale;

void main()
{
    //激活 未死亡
    float activeAndAlive = (1.0 - sign(iActiveDelay_Life[0])) * sign(iActiveDelay_Life[1]);

    gl_Position = uMVPMatrix * (activeAndAlive * vec4(iPosition, 1.0));
    gl_PointSize = activeAndAlive * uPointSize;
    vAngle = iAngle;
    vTransparency = activeAndAlive * iTransparency;
    vScale = activeAndAlive * (1.0 - step(iScale, 0.0)) * iScale;
}
