#version 330
precision highp int;
precision highp float;
in vec2 vTexCoord;
layout(location = 0) out vec4 fBloomColor;
uniform sampler2D uSceneTexture;

//计算亮度
float getGray(vec4 aColor)
{
    return aColor[0] * 0.299 + aColor[1] * 0.587 + aColor[2] * 0.114;
}

void main()
{
    vec4 sceneColor = texture(uSceneTexture, vTexCoord);
    if(sceneColor[3] == 0.0f)
    {
        discard;
        return;
    }

    fBloomColor = sceneColor;
    const float BloomThreshold = 0.5;
    float gray = getGray(fBloomColor);
    fBloomColor = (gray > BloomThreshold) ? (fBloomColor * sqrt(gray - BloomThreshold)) : vec4(0);
    fBloomColor[3] = sceneColor[3];
}
