#version 330
layout(location = 0) in float iLoop;

layout(location = 1) in vec2 iOriginalActiveDelay_OriginalLife;
layout(location = 2) in vec2 iActiveDelay_Life;

layout(location = 3) in vec3 iOriginalPosition;
layout(location = 4) in vec3 iPosition;

layout(location = 5) in vec3 iOriginalLinearVelocity;
layout(location = 6) in vec3 iLinearVelocity;

layout(location = 7) in vec3 iLinearAcceleration;

const int Index_Angle = 0;
const int Index_AngularVelocity = 1;
const int Index_AngularAcceleration = 2;
layout(location = 8) in vec3 iOriginalAngularProperties;
layout(location = 9) in vec3 iAngularProperties;

const int Index_Transparency = 0;
const int Index_TransparencyVelocity = 1;
layout(location = 10) in vec2 iOriginalTransparencyProperties;
layout(location = 11) in vec2 iTransparencyProperties;

const int Index_Scale = 0;
const int Index_ScaleVelocity = 1;
layout(location = 12) in vec2 iOriginalScaleProperties;
layout(location = 13) in vec2 iScaleProperties;

out float vLoop;
out vec2 vOriginalActiveDelay_OriginalLife;
out vec2 vActiveDelay_Life;
out vec3 vOriginalPosition;
out vec3 vPosition;
out vec3 vOriginalLinearVelocity;
out vec3 vLinearVelocity;
out vec3 vLinearAcceleration;
out vec3 vOriginalAngularProperties;
out vec3 vAngularProperties;
out vec2 vOriginalTransparencyProperties;
out vec2 vTransparencyProperties;
out vec2 vOriginalScaleProperties;
out vec2 vScaleProperties;

void main()
{
    float notActived = sign(iActiveDelay_Life[0]);
    float actived = 1.0 - notActived;

    float notDeaded = sign(iActiveDelay_Life[1]);
    float deaded = 1.0 - notDeaded;
    
    vLoop = iLoop;
    float notLoop = 1.0 - iLoop;

    vOriginalActiveDelay_OriginalLife = iOriginalActiveDelay_OriginalLife;
    vActiveDelay_Life[0] = max(iActiveDelay_Life[0] - 1.0, 0.0);
    vActiveDelay_Life[1] = notActived * iActiveDelay_Life[1] + actived * max(iActiveDelay_Life[1] - 1.0, 0.0);
    vActiveDelay_Life = iLoop * (notDeaded * vActiveDelay_Life + deaded * iOriginalActiveDelay_OriginalLife) + notLoop * vActiveDelay_Life;

    vOriginalPosition = iOriginalPosition;
    vPosition = iPosition + actived * iLinearVelocity;
    vPosition = notDeaded * vPosition + deaded * iOriginalPosition;

    vOriginalLinearVelocity = iOriginalLinearVelocity;
    vec3 updatedLinearVelocity = iLinearVelocity + iLinearAcceleration;
    vLinearVelocity = notActived * iLinearVelocity + actived * updatedLinearVelocity;
    vLinearVelocity = notDeaded * vLinearVelocity + deaded * iOriginalLinearVelocity;

    vLinearAcceleration = iLinearAcceleration;

    vOriginalAngularProperties = iOriginalAngularProperties;
    vAngularProperties[Index_Angle] = iAngularProperties[Index_Angle] + actived * iAngularProperties[Index_AngularVelocity];
    float updatedAngularVelocity = iAngularProperties[Index_AngularVelocity] + iAngularProperties[Index_AngularAcceleration];
    vAngularProperties[Index_AngularVelocity] = notActived * iAngularProperties[Index_AngularVelocity]
                                              + actived * updatedAngularVelocity;
    vAngularProperties[Index_AngularAcceleration] = iAngularProperties[Index_AngularAcceleration];
    vAngularProperties = notDeaded * vAngularProperties + deaded * iOriginalAngularProperties;

    vOriginalTransparencyProperties = iOriginalTransparencyProperties;
    float updatedTransparency = iTransparencyProperties[Index_Transparency] + actived * iTransparencyProperties[Index_TransparencyVelocity];
    vTransparencyProperties[Index_Transparency] = notActived * iTransparencyProperties[Index_Transparency]
                                                + actived * updatedTransparency;
    vTransparencyProperties[Index_TransparencyVelocity] = iTransparencyProperties[Index_TransparencyVelocity];
    vTransparencyProperties = notDeaded * vTransparencyProperties + deaded * iOriginalTransparencyProperties;

    vOriginalScaleProperties = iOriginalScaleProperties;
    float updatedScale = iScaleProperties[Index_Scale] + actived * iScaleProperties[Index_ScaleVelocity];
    vScaleProperties[Index_Scale] = notActived * iScaleProperties[Index_Scale]
                                  + actived * updatedScale;
    vScaleProperties[Index_ScaleVelocity] = iScaleProperties[Index_ScaleVelocity];
    vScaleProperties = notDeaded * vScaleProperties + deaded * iOriginalScaleProperties;
}

