#version 330
precision highp int;
precision highp float;
in vec2 vTexCoord;
layout(location = 0) out vec4 fColor;

//透明度
uniform float uAlpha;

uniform sampler2D uColorTexture;

//闪光
uniform int uMaxFlashDelay;
uniform int uFlashDelay;
//uniform float uFlashRed;
//uniform float uFlashGreen;
//uniform float uFlashBlue;
uniform vec3 uFlashColor;

void main()
{
    vec4 texColor = texture(uColorTexture, vTexCoord);
//    fColor = texColor;

//    int inFlashing = sign(uFlashDelay);
//    int notInFlashing = 1 - inFlashing;
//    vec4 flashColor = vec4(uFlashRed, uFlashGreen, uFlashBlue, fColor[3]);
    fColor = mix(texColor, vec4(uFlashColor, texColor[3]), vec4(float(uFlashDelay) / float(uMaxFlashDelay)));
    fColor[3] *= uAlpha;
}
